## liri-terminal-0.2.0.20200620-1.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

project("Terminal"
    VERSION "0.2.0"
    DESCRIPTION "Terminal emulator"
    LANGUAGES CXX C
)

## Shared macros and functions:
if(NOT LIRI_LOCAL_ECM)
    find_package(LiriCMakeShared "1.0.0" REQUIRED NO_MODULE)
    list(APPEND CMAKE_MODULE_PATH "${LCS_MODULE_PATH}")
endif()

## Set minimum versions required.
set(QT_MIN_VERSION "5.10.0")

## Liri specific setup common for all modules:
include(LiriSetup)

## Find Qt 5.
find_package(Qt5 "${QT_MIN_VERSION}"
    CONFIG REQUIRED
    COMPONENTS
        Core
        Gui
        Widgets
        Qml
        Quick
        QuickControls2
        LinguistTools
)

## Add subdirectories:
add_subdirectory(data)
add_subdirectory(src/lib)
add_subdirectory(src/imports/terminal)
add_subdirectory(src/app)

=== data/CMakeLists.txt ===
file(GLOB _files "*.gschema.xml")
install(FILES ${_files} DESTINATION "${INSTALL_DATADIR}/glib-2.0/schemas")

set(COLOR_SCHEMES
    color-schemes/BlackOnLightYellow.schema
    color-schemes/BlackOnRandomLight.colorscheme
    color-schemes/BlackOnWhite.schema
    color-schemes/Breeze.colorscheme
    color-schemes/cool-retro-term.schema
    color-schemes/DarkPastels.colorscheme
    color-schemes/GreenOnBlack.colorscheme
    color-schemes/Linux.colorscheme
    color-schemes/Material.colorscheme
    color-schemes/Solarized.colorscheme
    color-schemes/SolarizedLight.colorscheme
    color-schemes/Tango.colorscheme
    color-schemes/Ubuntu.colorscheme
    color-schemes/WhiteOnBlack.schema
)
install(FILES ${COLOR_SCHEMES} DESTINATION "${INSTALL_DATADIR}/liri-terminal/color-schemes")

set(KB_LAYOUTS
    kb-layouts/default.keytab
    kb-layouts/linux.keytab
    kb-layouts/macbook.keytab
    kb-layouts/solaris.keytab
    kb-layouts/vt420pc.keytab
)
install(FILES ${KB_LAYOUTS} DESTINATION "${INSTALL_DATADIR}/liri-terminal/kb-layouts")

=== src/app/CMakeLists.txt ===
# Translations
file(GLOB LiriTerminal_TRANSLATIONS "${CMAKE_SOURCE_DIR}/translations/*_*.ts")
qt5_add_translation(LiriTerminal_QM_FILES ${LiriTerminal_TRANSLATIONS})
install(FILES ${LiriTerminal_QM_FILES}
        DESTINATION "${INSTALL_DATADIR}/liri-terminal/translations")

liri_add_executable(LiriTerminal
    OUTPUT_NAME
        "liri-terminal"
    SOURCES
        ActionHandler.cpp
        ActionHandler.h
        fontfamiliesmodel.cpp
        fontfamiliesmodel.h
        main.cpp
        ${LiriTerminal_QM_FILES}
    RESOURCES
        terminal.qrc
    DEFINES
        #QT_NO_CAST_FROM_ASCII
        QT_NO_FOREACH
        TERMINAL_VERSION="${PROJECT_VERSION}"
    APPDATA
        "${CMAKE_CURRENT_SOURCE_DIR}/io.liri.Terminal.appdata.xml"
    DESKTOP
        "${CMAKE_CURRENT_SOURCE_DIR}/io.liri.Terminal.desktop"
    LIBRARIES
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Qml
        Qt5::Quick
        Qt5::QuickControls2
    GUI
)

=== src/lib/CMakeLists.txt ===
add_library(qmltermwidget STATIC
    BlockArray.cpp
    BlockArray.h
    ColorScheme.cpp
    ColorScheme.h
    Emulation.cpp
    Emulation.h
    Filter.cpp
    Filter.h
    History.cpp
    History.h
    HistorySearch.cpp
    HistorySearch.h
    KeyboardTranslator.cpp
    KeyboardTranslator.h
    ProcessInfo.cpp
    ProcessInfo.h
    Pty.cpp
    Pty.h
    Screen.cpp
    Screen.h
    ScreenWindow.cpp
    ScreenWindow.h
    Session.cpp
    Session.h
    ShellCommand.cpp
    ShellCommand.h
    TerminalCharacterDecoder.cpp
    TerminalCharacterDecoder.h
    TerminalDisplay.cpp
    TerminalDisplay.h
    tools.cpp
    tools.h
    Vt102Emulation.cpp
    Vt102Emulation.h
    konsole_wcwidth.cpp
    konsole_wcwidth.h
    kprocess.cpp
    kprocess.h
    kpty.cpp
    kpty.h
    kptydevice.cpp
    kptydevice.h
    kptyprocess.cpp
    kptyprocess.h
)
target_include_directories(qmltermwidget
    PUBLIC
        "${CMAKE_CURRENT_SOURCE_DIR}"
    PRIVATE
        "${CMAKE_CURRENT_SOURCE_DIR}/../imports/terminal"
)
target_compile_definitions(qmltermwidget
    PRIVATE
        HAVE_POSIX_OPENPT
        HAVE_SYS_TIME_H
)
target_link_libraries(qmltermwidget
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::Quick
)

=== src/imports/terminal/CMakeLists.txt ===
liri_add_qml_plugin(liriterminal
    MODULE_PATH
        "Liri/Terminal"
    SOURCES
        ksession.cpp
        ksession.h
        qmltermwidget_plugin.cpp
        qmltermwidget_plugin.h
    QML_FILES
        qmldir
        QMLTermScrollbar.qml
    DEFINES
        #QT_NO_CAST_FROM_ASCII
        QT_NO_FOREACH
    LIBRARIES
        qmltermwidget
)

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Michael Spencer <sonrisesoftware@gmail.com>

pkgname=liri-terminal
pkgver=0.2.0.20200620
_commit=1c179a463a22a5a6a04e68c01eceaa5b8d89070e
pkgrel=1
pkgdesc="Terminal for Liri"
arch=("x86_64")
url="https://github.com/lirios/terminal"
license=("GPL")
depends=('fluid' 'qt5-gsettings')
makedepends=('cmake' 'liri-cmake-shared' 'ninja' 'qt5-tools')
replaces=('papyros-terminal')
source=("https://github.com/lirios/terminal/archive/$_commit/$pkgname-$_commit.tar.gz")
sha256sums=('d03baa12bc169a95eb9e60348d421d435ab8d48a805720e6cfdff46fd218a6dc')

build() {
  cd terminal-$_commit
  cmake -GNinja -DCMAKE_INSTALL_PREFIX=/usr .
  ninja
}

package() {
  cd terminal-$_commit
  DESTDIR="$pkgdir" ninja install
}
